#include <InterfaceDefs.h>

/*============================================================================*/
/*
		コンテナローダー　フォルダ用		for Light MIDI
*/
const char*	gAddOnName = "Container Loader Folder";
const char*	gAddOnVer = "Ver 1.10";
const char*	gCright = "Copyright "B_UTF8_COPYRIGHT" 2002 by SHINTA";
const char*	gDescription = "Tells MIDI files in the folder.";
/*============================================================================*/

/*==============================================================================
 Ver. |					主な改良点
--------------------------------------------------------------------------------
 ---- | 2002.01.02.We 開発着手。
 1.00 | 2002.01.02.We オリジナルバージョン。
 1.10 | 2002.01.08.Tu 第 2 世代仕様に準拠した。
==============================================================================*/

/*=== Memo =====================================================================
==============================================================================*/

//------------------------------------------------------------------------------
#include "CLFolder.h"
//------------------------------------------------------------------------------
// BeOS
#include <Directory.h>
#include <Path.h>
// C++
// Add
// Proj
//------------------------------------------------------------------------------
//==============================================================================
TCLFolder::TCLFolder(const string& oPath)
		: SUPER(oPath)
{
}
//------------------------------------------------------------------------------
TCLFolder::~TCLFolder()
{
}
//------------------------------------------------------------------------------
string	TCLFolder::Copyright() const
{
	return gCright;
}
//------------------------------------------------------------------------------
string	TCLFolder::Description() const
{
	return gDescription;
}
//------------------------------------------------------------------------------
bool	TCLFolder::IsLoadable(const entry_ref& oERef,TSupportFmt* oFmt) const
{
	BEntry	aEntry(&oERef);

	*oFmt = SF_FOLDER;
	// oERef がフォルダならばロード可能
	// If oERef is a folder, this add-on can load it
	return aEntry.IsDirectory();
}
//------------------------------------------------------------------------------
status_t	TCLFolder::Load(const entry_ref& oERef,list<string>* oFiles)
{
	entry_ref		aMemberERef;		// フォルダ中のファイルやフォルダ
	BDirectory		aThisDir;

	if ( aThisDir.SetTo(&oERef) != B_OK )
		return B_ERROR;
	// フォルダ中のファイルを全て oFiles に追加
	// Add all files in the folder to oFiles
	aThisDir.Rewind();
	while ( aThisDir.GetNextRef(&aMemberERef) == B_OK ) {
		oFiles->push_back(BPath(&aMemberERef).Path());
	}
	return B_OK;
}
//------------------------------------------------------------------------------
string	TCLFolder::Name() const
{
	return gAddOnName;
}
//------------------------------------------------------------------------------
string	TCLFolder::Version() const
{
	return gAddOnVer;
}
//==============================================================================
TContainerLoader*	make_container_loader(const string& oPath,image_id oImgID)
{
	return new TCLFolder(oPath);
}
//==============================================================================
