#ifndef	___CLRaw_H_
#define	___CLRaw_H_
//------------------------------------------------------------------------------
// BeOS
#include <image.h>
// C++
// Add
// Proj
#include "ContainerLoader.h"
//------------------------------------------------------------------------------
const char	FILE_EXT_MIDI[] = "mid";									// MIDI ファイルの拡張子
//------------------------------------------------------------------------------
const int	FREAD_BUF_SIZE = 2048;									// ファイルバッファ
const int	SEMI_RAW_FMT_DISTINCT_BREAK_LINES = 10;					// 単純リストの判別を打ち切る行数
//==============================================================================
class	TCLRaw : public TContainerLoader
{
public:
	TCLRaw(const string& oPath);
	~TCLRaw();

	// ロード
	virtual bool		IsLoadable(const entry_ref& oERef,TSupportFmt* oFmt) const;	// ロード可能かどうか
	virtual status_t	Load(const entry_ref& oERef,list<string>* oFiles);			// ロード

	// アドオンの情報
	virtual string		Name() const;			// アドオンの名前
	virtual string		Version() const;		// アドオンのバージョン
	virtual string		Copyright() const;		// アドオンの著作権情報
	virtual string		Description() const;	// アドオンの説明

private:
	typedef	TContainerLoader	SUPER;

	ssize_t		GetLine(BFile* oFile,char* oBuf,int oBufSize) const;	// 1 行読み込む
	bool		IsMidiFileName(const char* oFileName) const;			// MIDI ファイルかどうか
};
//==============================================================================
/*	''''''''''''''''''''''''''''''
Light MIDI がアドオンを読み込めるように、make_container_loader はエクスポートしておかなければならない
make_container_loader must be exported
,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,	*/
extern "C" _EXPORT TContainerLoader*	make_container_loader(const string& oPath,image_id oImgID);
//==============================================================================
#endif	// ___CLRaw_H_
