#ifndef	___ContainerLoader_H_
#define	___ContainerLoader_H_
//------------------------------------------------------------------------------
// BeOS
#include <Entry.h>
// C++
#include <list>
#include <string>
// Add
// Proj
#include "SupportFormat.h"
//------------------------------------------------------------------------------
using namespace	std;
//------------------------------------------------------------------------------
const int32	CL_SPECIFICATION_NUMBER = 2;
//==============================================================================
class	TContainerLoader
{
////////// 互換性チェック ; for compatibility check //////////
private:
	virtual int32		SpecificationNumber() const;
////////////////////////////////////////////////////////////////

public:
	virtual	~TContainerLoader();

	// ロード ; Load
	virtual bool		IsLoadable(const entry_ref& oERef,TSupportFmt* oFmt) const = 0;	// ロード可能かどうか ; Can load or not
	virtual status_t	Load(const entry_ref& oERef,list<string>* oFiles) = 0;			// ロード ; Load

	// アドオンの情報 ; Informations about add-on
	virtual string		Name() const = 0;			// アドオンの名前 ; Add-on's name
	virtual string		Version() const = 0;		// アドオンのバージョン ; Add-on's version
	virtual string		Copyright() const = 0;		// アドオンの著作権情報 ; Add-on's copyright
	virtual string		Description() const = 0;	// アドオンの説明 ; Add-on's description

	// フルパス ; Add-on's full path
	string				Path() const;

protected:
	TContainerLoader(const string& oPath);

private:
	friend	void	load_container_loader(list<TContainerLoader*>*);

	string	mPath;			// アドオンのフルパス ; Add-on's full path
};
//==============================================================================
#endif	// ___ContainerLoader_H_
